boolean flip = 0;

#define LED 2

uint32_t data_1_32;
uint16_t data_1_16;
uint32_t data_2_32;
uint16_t data_2_16;
uint32_t data;
int n1;
int n2;

boolean need_sample = 1;
boolean got_sample = 0;

unsigned int time_before = 0;

boolean mono_mode = 1;

String file1_name;
String file1_last_4_chars;

String file2_name;
String file2_last_4_chars;

unsigned int sample_counter = 0;
unsigned int buffer_counter = 0;

unsigned int buffer_length = 256;

//------------//
//---INPUTS---//
//------------//
#define TRIG1 0
#define TRIG2 1

boolean TRIG1_state = 0;
boolean previous_TRIG1_state = 0;
unsigned int debounce_TRIG1 = 0;

//-------------------//
//----I2S Config-----//
//-------------------//
//i2s configuration
int i2s_num = 0; // i2s port number
i2s_config_t i2s_config = {
  .mode = (i2s_mode_t)(I2S_MODE_MASTER | I2S_MODE_TX),
  .sample_rate = 44100,
  .bits_per_sample = I2S_BITS_PER_SAMPLE_16BIT,
  .channel_format = I2S_CHANNEL_FMT_RIGHT_LEFT,
  .communication_format = (i2s_comm_format_t)(I2S_COMM_FORMAT_I2S | I2S_COMM_FORMAT_I2S_MSB),
  .intr_alloc_flags = ESP_INTR_FLAG_LEVEL1, // high interrupt priority
  .dma_buf_count = 8,
  .dma_buf_len = 64   //Interrupt level 1
};

i2s_pin_config_t pin_config = {
  .bck_io_num = 26, //this is BCK pin
  .ws_io_num = 25, // this is LRCK pin
  .data_out_num = 22, // this is DATA output pin
  .data_in_num = I2S_PIN_NO_CHANGE
};

//-------------------//
//--SD and AUDIO-----//
//-------------------//
uint8_t buf1[2];
uint8_t buf1_a[512];
uint8_t buf1_b[512];

uint8_t buf2[2];
uint8_t buf2_a[512];
uint8_t buf2_b[512];

bool prepare_bytes = 1;

bool flip_flop = 0;
bool flip_flop_1 = 0;
bool flip_flop_2 = 0;

bool buffered_1_b = 0;
bool buffered_1_a = 0;

bool buffer_refill_1 = 0;
bool buffer_refill_2 = 0;

unsigned long buffer_counter_1 = 0;
unsigned long buffer_counter_2 = 0;

unsigned long length_audio1 = 0;
unsigned long length_audio2 = 0;
unsigned int bit_depth_1 = 0;
unsigned int bit_depth_2 = 0;
unsigned int bit_shift = 0;

unsigned int sample_rate_1 = 0;
unsigned int sample_rate_1_msb = 0;
unsigned int sample_rate_1_lsb = 0;

unsigned int sample_rate_2 = 0;
unsigned int sample_rate_2_msb = 0;
unsigned int sample_rate_2_lsb = 0;

unsigned int number_of_channels_1 = 0;
unsigned int number_of_channels_2 = 0;

unsigned long reading = 0;
unsigned long reading_2 = 0;
unsigned long reading_3 = 0;
unsigned long reading_4 = 0;
unsigned long start_byte_1 = 0;
unsigned long start_byte_2 = 0;

char name_1[20];
char name_2[20];
byte name_1_size[13];
byte name_2_size[13];

unsigned long before = 0;
unsigned long after = 0;

volatile unsigned long counter1 = 0;
volatile unsigned long counter2 = 0;

volatile bool play1 = 0;
volatile bool play2 = 0;

bool rewind_1 = 0;
bool rewind_2 = 0;

int error_sd = 0;
