void sd_init_files() {
  //-----------------//
  //---Open FILE1----//
  //-----------------//
  Serial.println("Parsing FILE1 now");

  // sd.vwd()->rewind();
  // file1.openNext (sd.vwd(), O_READ);
  //  file1.printName(&Serial);

  if (!file1.open("para.wav")) {
  }

  /*
    while (file2_last_4_chars != ".WAV") {
    file2 = sd.open("/2.WAV");
    file2_name = file2.name();
    file2_last_4_chars = file2_name.substring(file2_name.length() - 4, file2_name.length());
    }
  */


  for (int i = 0; i < 100; i++) {
    reading = file1.read();

    if (reading == 0x66) {
      reading_2 = file1.read();
      reading_3 = file1.read();
      reading_4 = file1.read();

      //search for Subchunk1ID, Contains the letters, "fmt " (0x666d7420 big-endian form).
      if ((reading_2 == 0x6d) && (reading_3 == 0x74) && (reading_4 == 0x20)) {
        break;
      }
    }
  }

  Serial.print("Subchunk1 ID start at : ");
  Serial.println(file1.curPosition() - 4, DEC);

  //after the Subchunk1ID, we know for sure that the next bytes define important information
  //skip Subchunk1Size
  for (int i = 0; i < 4; i++) {
    file1.read();
  }

  //skip AudioFormat
  for (int i = 0; i < 2; i++) {
    file1.read();
  }

  //get number of channels
  number_of_channels_1 = file1.read();
  Serial.print("number of channels : ");
  Serial.println(number_of_channels_1, DEC);
  //byte 2 is empty
  file1.read();

  //get sample rate
  sample_rate_1_lsb = file1.read();
  sample_rate_1_msb = file1.read();
  sample_rate_1 = sample_rate_1_lsb;
  sample_rate_1 |= sample_rate_1_msb << 8;
  Serial.print("sample_rate : ");
  Serial.println(sample_rate_1, DEC);
  //byte 3 & 4 are empty
  file1.read();
  file1.read();

  //skip bytes until bitdepth
  for (int i = 0; i < 6; i++) {
    file1.read();
  }

  //bit depth
  bit_depth_1 = file1.read();
  Serial.print("bitdepth : ");
  Serial.println(bit_depth_1, DEC);
  file1.read();

  //scroll through file until reaching the Subchunk2ID
  for (int i = 0; i < 1000; i++) {
    reading = file1.read();
    //Serial.print(i);
    // Serial.print("  -  ");
    // Serial.println(reading, HEX);

    if (reading == 0x64) {
      reading_2 = file1.read();
      reading_3 = file1.read();
      reading_4 = file1.read();

      //search for Subchunk2ID, Contains the letters "data" (0x64617461 big-endian form).
      if ((reading_2 == 0x61) && (reading_3 == 0x74) && (reading_4 == 0x61)) {
        break;
      }
    }
  }

  Serial.print("Subchunk2ID start at : ");
  Serial.println(file1.curPosition() - 4, DEC);

  //we then reached the Subchunk2Size, and can read the length of the file
  reading =  file1.read();
  length_audio1 = reading;
  reading =  file1.read();
  length_audio1 |= reading << 8;
  reading =  file1.read();
  length_audio1 |= reading << 16;
  reading =  file1.read();
  length_audio1 |= reading << 32;

  //length of audio in samples, it's the half of the amount of bytes in mono 16bits
  //length_audio1 = length_audio1 / 2;

  Serial.println(length_audio1);

  start_byte_1 = file1.curPosition();

  Serial.print("audio starting start at : ");
  Serial.println(start_byte_1, DEC);

  //to avoid starting playback when powering module
  //jump to the end, it's also like a stop function
  
  file1.seekSet(file1.fileSize());

  //-----------------//
  //---Open FILE2---//
  //----------------//
  Serial.println("Parsing FILE2 now");

  /*
    while (file2_last_4_chars != ".WAV") {
      file2 = sd.open("/2.WAV");
      file2_name = file2.name();
      file2_last_4_chars = file2_name.substring(file2_name.length() - 4, file2_name.length());
    }
  */

  if (!file2.open("wake_up.wav")) {
  }

  for (int i = 0; i < 100; i++) {
    reading = file2.read();

    if (reading == 0x66) {
      reading_2 = file2.read();
      reading_3 = file2.read();
      reading_4 = file2.read();

      //search for Subchunk1ID, Contains the letters, "fmt " (0x666d7420 big-endian form).
      if ((reading_2 == 0x6d) && (reading_3 == 0x74) && (reading_4 == 0x20)) {
        break;
      }
    }
  }

  Serial.print("Subchunk1 ID start at : ");
  Serial.println(file2.curPosition() - 4, DEC);

  //after the Subchunk1ID, we know for sure that the next bytes define important information
  //skip Subchunk1Size
  for (int i = 0; i < 4; i++) {
    file2.read();
  }

  //skip AudioFormat
  for (int i = 0; i < 2; i++) {
    file2.read();
  }

  //get number of channels
  number_of_channels_2 = file2.read();
  Serial.print("number of channels : ");
  Serial.println(number_of_channels_2, DEC);
  //byte 2 is empty
  file2.read();

  //get sample rate
  sample_rate_2_lsb = file2.read();
  sample_rate_2_msb = file2.read();
  sample_rate_2 = sample_rate_2_lsb;
  sample_rate_2 |= sample_rate_2_msb << 8;
  Serial.print("sample_rate : ");
  Serial.println(sample_rate_2, DEC);
  //byte 3 & 4 are empty
  file2.read();
  file2.read();

  //skip bytes until bitdepth
  for (int i = 0; i < 6; i++) {
    file2.read();
  }

  //bit depth
  bit_depth_2 = file2.read();
  Serial.print("bitdepth : ");
  Serial.println(bit_depth_1, DEC);
  file2.read();

  //scroll through file until reaching the Subchunk2ID
  for (int i = 0; i < 1000; i++) {
    reading = file2.read();
    //Serial.print(i);
    // Serial.print("  -  ");
    // Serial.println(reading, HEX);

    if (reading == 0x64) {
      reading_2 = file2.read();
      reading_3 = file2.read();
      reading_4 = file2.read();

      //search for Subchunk2ID, Contains the letters "data" (0x64617461 big-endian form).
      if ((reading_2 == 0x61) && (reading_3 == 0x74) && (reading_4 == 0x61)) {
        break;
      }
    }
  }

  Serial.print("Subchunk2ID start at : ");
  Serial.println(file2.curPosition() - 4, DEC);

  //we then reached the Subchunk2Size, and can read the length of the file
  reading =  file2.read();
  length_audio2 = reading;
  reading =  file2.read();
  length_audio2 |= reading << 8;
  reading =  file2.read();
  length_audio2 |= reading << 16;
  reading =  file2.read();
  length_audio2 |= reading << 32;

  //length of audio in samples, it's the half of the amount of bytes in mono 16bits
  //length_audio1 = length_audio1 / 2;

  Serial.println(length_audio2);

  start_byte_2 = file2.curPosition();

  Serial.print("audio starting start at : ");
  Serial.println(start_byte_2, DEC);

  //to avoid starting playback when powering module
  //jump to the end, it's also like a stop function
  //file2.seekSet(file2.size());
  file2.seekSet(file2.fileSize());

}
